
      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      Parameter(NN=200000000)
      
      Parameter(NNN=1000000)
      Parameter(Nfile=10)

      real*8 time(NN)
      real ave(Nfile),fftr(NNN),avebgd(Nfile),Tave,Taveseg
       COMPLEX fft(Nfile,NNN),coher(Nfile,NNN),Tcoher(Nfile),cval,cvala
       COMPLEX cohertot(Nfile,NNN)
       real signi(Nfile)
       real*8 Emin(Nfile),Emax(Nfile)
       real P(Nfile,NNN),PT(NNN),PTT(Nfile),Ptot(Nfile,NNN),PTTT(NNN)
       character*50 filename(Nfile),fileout1,fileout2,energy_cha_file
       character*50 user_gti_file,fileout,eneinput
        character*1 fj
	character*3 pcu
        character*200 command,enename
       integer itstart(500),itstop(500),nrows(Nfile),jtime(Nfile)
       integer icmin(Nfile),icmax(Nfile)
	integer itstartu(500),itstopu(500),ich(2000)
        real ecmin(2000),ecmax(2000)


        real time_resl
        

        real*8 Tbkg(50),Tbkgerr(50),err_l(50)
        integer*1 ia1
       logical dofft,gtinotfits
       
       
      
       call get_info(filename(1),pcu,deltat,user_gti_file,fileout
     1  ,eneinput,ilayer)


       jfile_num=1
       Emin(1) = 3.0
       Emax(1) = 80.0
       freq_min=1./deltat

        open(unit=30,err=83,file=eneinput,status='old')

c$$$        
c$$$	read(30,*) filename(1)
c$$$        read(30,*) pcu
c$$$       read(30,*) deltat
c$$$       read(30,*) user_gti_file
c$$$       read(30,*) fileout
c$$$
c$$$       freq_min=1./deltat

        do j = 1,9
           read(30,*,end=41,err=41)Emin(j),Emax(j)
           jfile_num=j
       enddo
 41    continue


       

       close(30)

 83    continue
       
       
       
      
        if(jfile_num .gt. 9)then
          write(*,*) 'Too many lightcurves'
          stop
       endif
       

       do j=1,jfile_num
          Tbkg(j) = 0.0
          Tbkgerr(j)=0.0
       enddo


c$$$       open(unit=42,err=82,file='backrates',status='old')
c$$$
c$$$       do j=1,jfile_num
c$$$          
c$$$          
c$$$          read(42,*) Tbkg(j),Tbkgerr(j)
c$$$       enddo
c$$$
c$$$       close(42)
c$$$
c$$$ 82    continue

       nsegments=1

       
       IND = 1
       do while (IND .eq. 1)
          IND = index(fileout,' ')
          if(IND .eq. 1)then
             fileout=fileout(IND+1:)
          endif
       enddo

       fileout2=fileout(:IND-1)//'.txt'

       open(unit=30,file=fileout2)

       write(30,*)'! Time,count rate and error  in the following 
     1 energy bins' 
       do j=1,jfile_num
       write(30,*)'! ',j+1,': ',Emin(j),' - ',Emax(j),' keV'
       enddo

       

      

       do jf =1,jfile_num
          js = 30+jf
          
          open(unit=27,file='thrash')
          write(27,*) jf
          rewind(27)
          read(27,*) fj
          close(27)
          
          open(unit=js,file=fileout(:IND-1)//fj)
       enddo

       NNC = NN/jfile_num

      
      call read_data_fits(time,imax,deltat,NN,filename,ave
     1,itstart,itstop,jgti,freq_max,timemem,NNC,nrows
     2,jfile_num,itstartu,itstopu,jgtiu,Emin,Emax,jfile_num,pcu
     3, user_gti_file,gtinotfits,ilayer)


!       call calback(deltat,Emin,Emax,jfile_num,ave,avebgd,
!     1file_bkg_pha,file_bkg_rsp)

      do j=1,jfile_num
         avebgd(j) = 0.0
      enddo
     
      

     
      

!      jamaxn = 2**nint(log(1./(freq_min*deltat))/log(2.0))

      jamaxn = nint(1./(freq_min*deltat))
      
c$$$      if(jamaxn .gt. NNN)then
c$$$         write(*,*) 'too many points per segment', jamaxn,NNN
c$$$!         stop
c$$$      endif

      iseg = imax/jamaxn

      
      freq_max = 1./deltat/2.
      freq_min = 1./(jamaxn*deltat)
      ja = int(float(itstop(jgti))/float(jamaxn))
      
      iseg = min(iseg,ja)
     
      write(*,*) 'total no of points in lC= ',iseg
      
     
     

      time_resl=1./freq_min

      write(*,*) 'time resultion (secs) = ', time_resl
     
      iseg_part = iseg/nsegments


      taveseg=0.0
      write(*,*) "start time" , " integer stop time" ,jgti
      do j=1,jgti
         
         write(*,*) (itstart(j)-1)*deltat,itstop(j)*deltat
      enddo
	if(jgtiu .ne. 0)then
	write(*,*) "User start and stop time" 
	do j=1,jgtiu
         
         write(*,*) (itstartu(j)-1)*deltat,itstopu(j)*deltat
      enddo
	endif
      isegn=0
      isega = 0
      isegr=0
      itnum=1
      itnumu=1
      fpeak=0.0
      ppeak=0.0
      
      P1t = 0.0
      P2t = 0.0
      Tfreq = 0.0
      iseg_partn=0
      do j=1,jfile_num
      jtime(j)=1
      Tcoher(j)=(0.0,0.0)
      PTT(j) = 0.0
      enddo




      do ia =1,iseg
         

          do jf = 1,jfile_num
          ave(jf) = 0.0
          enddo
          Taveage=0.0


      ja = (ia-1)*jamaxn
      dofft=.true.
      if(ja+1 .lt. itstart(itnum))dofft=.false.
      if(ja+jamaxn .gt. itstop(itnum))then

        
         dofft=.false.
         if(itnum .lt. jgti)itnum=itnum+1
      endif

	if(jgtiu .ne. 0)then
	
	if(ja+1 .lt. itstartu(itnumu))dofft=.false.
          if(ja+jamaxn .gt. itstopu(itnumu))then

         
             
            dofft=.false.
            if(itnumu .lt. jgtiu)itnumu=itnumu+1
          endif
	
        endif
	
      if(dofft)then

         do jf = 1,jfile_num
            
 
        
 100     continue
         ja1 = int((time((jf-1)*NNC+jtime(jf))-timemem)/deltat)+1 
     1         - (ia-1)*jamaxn

         

         if(jtime(jf) .lt. nrows(jf))then
         if(ja1 .le. jamaxn)then

           if(ja1 .gt. 0)then
!              fftr(ja1) =fftr(ja1)+1.
              ave(jf) = ave(jf)+1
              Taveseg = Taveseg+1
           endif
            jtime(jf)=jtime(jf)+1
         goto 100
         else
         endif   
         endif
         
       enddo



       do j=1,jfile_num
          erra = sqrt(ave(j))/time_resl
          ave(j) = ave(j)/time_resl
          ave(j) = ave(j)-Tbkg(j)
          err_l(j) = sqrt(erra**2 + Tbkgerr(j)**2)
       enddo   

       write(30,*) (ia-1)*time_resl,(ave(jf),err_l(jf),jf=1,jfile_num)
     1 ,(ia-1)*time_resl+timemem

       do jf = 1,jfile_num
          write(30+jf,*) (ia-1)*time_resl+timemem, ave(jf),err_l(jf)
       enddo
       
       Tstopa = (ia-1)*time_resl+timemem

       endif

      

       enddo
       close(30)

       if(jgtiu .ne. 0)then
          IND2 = 1
       do while (IND2 .eq. 1)
          IND2 = index(user_gti_file,' ')
          if(IND2 .eq. 1)then
              user_gti_file= user_gti_file(IND2+1:)
          endif
       enddo
       endif

       if(jgtiu .ne. 0 .and. gtinotfits)then
        open(unit=30,file='coldesc.lis')

       write(30,*)'START D  s'
       write(30,*)'STOP D  count/s'
              
       close(30)

       open(unit=30,file='thrash')
       do j=1,jgtiu
          write(30,*) itstartu(j)*deltat+timemem,itstopu(j)
     1*deltat+timemem
       enddo
       close(30)

       

       command="fcreate coldesc.lis "// 'thrash'// 
     1  " "//user_gti_file(:IND2-1)//".fits"//" clobber=yes 
     2 extname=USER_GTI" 

 !      write(*,*) command
       call system(command)


       endif
       open(unit=30,file='coldesc.lis')

       write(30,*)'TIME D  s'
       write(30,*)'RATE E  count/s'
       write(30,*)'ERROR E counts/s'
       
       close(30)

       do jf =1,jfile_num
          
          
          open(unit=27,file='thrash')
          write(27,*) jf
          rewind(27)
          read(27,*) fj
          close(27)
          
        open(unit=30,file='keyword.lis')

        

        write(30,*)'TIMEUNIT s'
        write(30,*)'TSTART  ', timemem
        write(30,*)'TSTOP  ', tstopa
        write(30,*)'TIMEDEL ', time_resl
        write(30,*) 'Emin  ', Emin(jf),' \ Energy minimum of lightcurve'
        write(30,*) 'Emax  ', Emax(jf),' \ Energy minimum of lightcurve'
        write(30,*) 'User_gti', jgtiu,' \ number of user gti' 
        write(30,*) 'PCUS ', pcu,' \PCUs used all--> 10,20 and 30 
     1 13 --> 10 and 30'

        

        close(30)


        open(unit=27,file='thrash')
        if(Emax(jf) .lt. 100.)then
        write(27,'(F4.1,A1,F4.1)')Emin(jf),'_',Emax(jf)
        else
        write(27,'(F4.1,A1,F5.1)')Emin(jf),'_',Emax(jf)
        endif
        rewind(27)
        read(27,*) enename
        close(27)
        INDA = 1
       do while (INDA .eq. 1)
          INDA = index(enename,' ')
          if(INDA .eq. 1)then
              user_gti_file= enename(INDA+1:)
          endif
       enddo
      
       fileout1= fileout(:IND-1)//'_'//enename(:INDA-1)//'keV.lc'

       INDC = 1
       do while (INDC .eq. 1)
          INDC = index(fileout1,' ')
          if(INDC .eq. 1)then
              fileout1= fileout1(INDC+1:)
          endif
       enddo

       
       
        
        
        command="fcreate coldesc.lis "//fileout(:IND-1)//fj// 
     1  " "//fileout1(:INDC-1)//" clobber=yes headfile 
     2  = keyword.lis extname=lightcurve"

!        write(*,*) command
        call system(command)

        command='cphead '//filename(1)//' '//fileout1(:INDC-1)
!         write(*,*) command
          call system(command)

        call system(command)

        

        if(jgtiu .ne. 0)then
           if(gtinotfits)then
           command="fappend "//user_gti_file(:IND2-1)//".fits"//
     1  " "//fileout1(:INDC-1)
           else
           command="fappend "//user_gti_file(:IND2-1)//
     1  " "//fileout1(:INDC-1)
           endif
!           write(*,*) command
           call system(command)
           
        endif
        
        command='rm -f '//fileout(:IND-1)//fj
        call system(command)

        enddo

        command='rm -f coldesc.lis keyword.lis thrash'
        call system(command)
        
       end




C     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine get_info(filename,pcu,deltat,user_gti_file,fileout
     1,eneinput,ilayer)

      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      character*50 filename,fileout,user_gti_file,eneinput
      
      character*3 pcu

      integer    larg,       mxopts
      parameter (larg = 256, mxopts = 64)
*
      integer            iarg, ptr, arglen, nflags, argidx
      logical            done, more, hasarg(mxopts)
      character          flags(mxopts)
      character *(larg)  arg, optarg
*
      common  / gtoptc /
     $     iarg, ptr, arglen, nflags, argidx, done, more, hasarg,
     $     flags, arg, optarg
*
      save / gtoptc /

      integer      status,getopt
        character      flag
        character*300 use_err,statement
        
        logical  argset, first

         filename='level2.event.fits'
         deltat = 1.0
        pcu = 'all'
         fileout = 'lightcurve'
        user_gti_file = 'none'
        eneinput='eneinput'
        ilayer=0

        use_err = '[-p (which pcu? all or e.g. 12)] [-t timebin] [-u (us 
     1er gti asci file)] [-o output filename] -e [energy define file]
     2-l [layer no] event_file_name'
        use_err = 'USAGE: Fits_Lightcurve '//use_err

       first = .true.
        argset=.false.
 485    continue

      status=getopt('p:t:u:o:e:l:',flag,argset,nargs,first)

      if (status .eq. 1) then
         
           if (flag .eq. 'p') then
                      if (argset) then
                    
                    read (optarg, '(A3)',err=945) pcu

                    goto 946
 945                continue
                    write(*,*) 'error reading argument for flag p'
                    write(*,*) 'Using all PCUS'
                    goto 9000
 946                continue
                    
                    endif
          endif
          if (flag .eq. 't') then
                      if (argset) then
                    
!                    read (optarg, '(D12.5)',err=955) deltat
                    read (optarg, *,err=955) deltat
                    
                    goto 956
 955                continue
                    write(*,*) 'error reading argument for flag t'
                    write(*,*) 'Taking default value of 1.0 sec'
                    goto 9000
 956                continue
                    
                    endif
          endif
          


        

        if (flag .eq. 'u') then
                      if (argset) then
                    
                    read (optarg, '(A50)',err=965) user_gti_file
                   
                    goto 966
 965                continue
                    write(*,*) 'error reading argument for flag u'
                    write(*,*) 'Using default value of no user gti'
                    goto 9000
 966                continue
                    
                    endif
          endif

          if (flag .eq. 'o') then
                      if (argset) then
                    
                    read (optarg, '(A50)',err=975) fileout
                   
                    goto 976
 975                continue
                    write(*,*) 'error reading argument for flag o'
                    write(*,*) 'Using default root of output file'
                    
                    goto 9000
 976                continue
                    
                    endif
          endif

           if (flag .eq. 'e') then
              
                      if (argset) then
                    
                    read (optarg, '(A50)',err=985) eneinput
                    
                    goto 986
 985                continue
                    write(*,*) 'error reading argument for flag e'
                    write(*,*) 'Using default energy file eneinput'
                    goto 9000
 986                continue
                    
                    endif
          endif

                     if (flag .eq. 'l') then
              
                      if (argset) then
                    
                    read (optarg, '(I3)',err=995) ilayer
                    
                    goto 996
 995                continue
                    write(*,*) 'error reading argument for flag l'
                    write(*,*) 'Using default all layers'
                    goto 9000
 996                continue
                    
                    endif
          endif
          
          
          goto 485
        endif

        if (status .lt. 0) then
       write(*,*) use_err
        go to 9000
      else
        if (nargs .eq. 0 .or. argidx .ne. nargs) then
           write(*,*) use_err
          go to 9000
        end if
      end if
             
        call getarg (nargs, filename)
       
       
 9000   continue
        write(*,*) 'Event file being used: ',filename
        write(*,*) 'User Time bin in seconds: ', deltat
        write(*,*) 'PCUs being used: ',pcu
        write(*,*) 'Output file name: ',fileout
        write(*,*) 'User GTI file name: ',user_gti_file
        write(*,*) 'Energy input filename: ',eneinput
        if(ilayer .gt. 0 .and. ilayer .lt. 6)then
           write(*,*) "extracting from Layer ", ilayer
        else
           ilayer=0
           write(*,*) "extracting from all layers "
        endif
      end

C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* -*- fortran -*- ------------------------------------------------------
*
*     John W. Eaton
*     jwe@che.utexas.edu
*     Department of Chemical Engineering
*     The University of Texas at Austin
*
*-----------------------------------------------------------------------
*
      integer function getopt (string, flag, argset, nargs, first)
*
      integer        nargs
      character      flag
      character *(*) string
      logical        argset, first
*
*-----------------------------------------------------------------------
*
      integer  stdin, stdout, stderr
*
      parameter ( stdin = 5, stdout = 6, stderr = 0 )

*
      integer    larg,       mxopts
      parameter (larg = 256, mxopts = 64)
*
      integer            iarg, ptr, arglen, nflags, argidx
      logical            done, more, hasarg(mxopts)
      character          flags(mxopts)
      character *(larg)  arg, optarg
*
      common  / gtoptc /
     $     iarg, ptr, arglen, nflags, argidx, done, more, hasarg,
     $     flags, arg, optarg
*
      save / gtoptc /
*
* -- End

*
      integer iargc, lennb, strln, i
*
      if (first) then
*
        first = .false.
*
* -- If the user passes in a character vector for the option string,
* -- he loses.
*
        strln = lennb (string, len (string))
*
        nflags = 0
        i = 1
    1   if (strln .gt. 0) then
          strln = strln - 1
          nflags = nflags + 1
          if (nflags .gt. mxopts) then
            write (stderr, '(a)')
     $           'getopt: too many flags in option list'
            getopt = -1
            return
          end if
          if (string(i:i) .eq. ':') then
            write (stderr, '(a)') 'getopt: garbled option list'
            getopt = -1
            return
          end if
          flags (nflags) = string(i:i)
          i = i + 1
          hasarg(nflags) = (string(i:i) .eq. ':')
          if (hasarg (nflags)) then
            i = i + 1
            strln = strln - 1
          end if
          go to 1
        end if
        done = .false.
        more = .false.
        iarg = 1
        nargs = iargc ()
      end if
*
      if (done) then
        write (stderr, '(a)') 'getopt: no more options'
        argset = .false.
        flag = ' '
        argidx = iarg
        getopt = 0
        return
      end if
*
      if (iarg .gt. nargs) then
        done = .true.
        argset = .false.
        flag = ' '
        argidx = iarg
        getopt = 0
        return
      end if
*
      if (.not. more) then
        call getarg (iarg, arg)
*
* -- Check for explicit end of options.
*
        if (arg .eq. '--') then
          done = .true.
          argset = .false.
          flag = ' '
          iarg = iarg + 1
          argidx = iarg
          getopt = 0
          return
        end if
*
* -- Does the argument match a flag?
*
        if (arg(1:1) .eq. '-') then
          more = .true.
          arglen = lennb (arg, len (arg))
          if (arglen .eq. 1) then
            done = .true.
            argset = .false.
            flag = ' '
            argidx = iarg
            getopt = 0
            return
          end if
          arglen = arglen - 1
          ptr = 2
*
        else
*
* -- End of options implied.
*
          done = .true.
          argset = .false.
          flag = ' '
          argidx = iarg
          getopt = 0
          return
*
        end if
      end if
*
* -- Process flags.
*
      do 10 i = 1, nflags
        if (arg(ptr:ptr) .eq. flags(i)) then
          flag = flags(i)
          if (hasarg(i)) then
            if (iarg .gt. nargs) then
              write (stderr, '(a)') 'getopt: option string missing'
              write (stderr, '(a,a)') 'getopt: option flag is: ', flag
              getopt = -1
              return
            end if
            iarg = iarg + 1
            call getarg (iarg, optarg)
            argset = .true.
          else
            argset = .false.
          end if
          getopt = 1
          go to 9000
        end if
   10 continue
*
      write (stderr, '(a,a)')
     $     'getopt: unrecognized option: -', arg(ptr:ptr)
      getopt = -1
*
 9000 continue
*
      ptr = ptr + 1
      arglen = arglen - 1
      more = (arglen .gt. 0)
      if (.not. more) then
        iarg = iarg + 1
      endif
      argidx = iarg
*
      return
      end
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* -*- fortran -*- ------------------------------------------------------
*
*     John W. Eaton
*     jwe@che.utexas.edu
*     Department of Chemical Engineering
*     The University of Texas at Austin
*
*-----------------------------------------------------------------------
*
      integer function lennb (string, nchmax)
*
      integer       nchmax
      character *1  string(*)
*
*-----------------------------------------------------------------------
*
*     Returns the position of the last non blank character in a
*     characterstring. 
*
*     Parameter list:
*
*       string : Character string for which one desires to find the
*                position of the last non blank character (from the
*                left).
*
*       nchmax : The maximum possible value of the position of the last
*                non blank character in string.  Lennb searches
*                backwards from this location.
*
*-----------------------------------------------------------------------
*
      integer i
*
* -- Begin.
*
      lennb = 0
*
      do 10 i = nchmax, 1, -1
        if (string(i) .ne. ' ') then
          lennb = i
          go to 9000
        end if
   10 continue
*
 9000 continue
*
      return
      end
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine read_usergti(user_gti_file,tstartu,tstopu,
     1 jgtiu,gtinotfits)

      IMPLICIT DOUBLE PRECISION(a-h,o-z)

      character*50 user_gti_file

      real*8 tstartu(500),tstopu(500)


      integer status,unit,readwrite,blocksize
      logical anynull
      logical casesan,gtinotfits

       casesan=.FALSE.
       gtinotfits=.true.
          
      	jgtiu=0
	open(unit=33,file=user_gti_file,status='old',err=212)
	
	j=1
213	continue
	read(33,*,err=214,end=212) tstartu(j),tstopu(j)
	jgtiu=j
	j=j+1
	goto 213
 212	continue
        goto 217

 214    continue
        if(jgtiu .eq. 0)then
           status=0
        call ftgiou(unit,status)
      
      readwrite=0
      call ftopen(unit,user_gti_file,readwrite,blocksize,status)

      if(status .gt. 0)return

      ntable = 2
      call ftmahd(unit,ntable,hdutype,status)
      if (status .gt. 0)then
        call printerror(status)
        return
      endif

      call ftgnrw(unit,jgtiu,status)
         
      irow=1
      ifelem=1
      call FTGCNO(unit,casesan,'START',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,jgtiu,nullj,tstartu,anynull
     1 ,status)

        irow=1
      ifelem=1
      call FTGCNO(unit,casesan,'STOP',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,jgtiu,nullj,tstopu,anynull
     1 ,status)

        
         if (status .gt. 0)then
        call printerror(status)
        jgtiu=0
        return
         endif
        
         gtinotfits=.false.

      endif

 217  continue

      

        end
C     +++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine read_data_fits(time,imax,deltat,NN,
     1filename,ave,itstart,itstop,jgti,freq_max,timemem,
     2NNC,nrows,jfile_num,itstartu,itstopu,jgtiu,Enemin,Enemax,Nfile,
     3pcu,user_gti_file,gtinotfits,ilayer)


      IMPLICIT DOUBLE PRECISION(a-h,o-z)


     
      real*8 time(NN)
      real*8 tstart(500),tstop(500)
	real*8 tstartu(500),tstopu(500)
      real deltata,deltatb,ave(jfile_num)
      integer nrows(jfile_num)
      integer icmin(jfile_num),icmax(jfile_num)
      real*8 Enemin(Nfile),Enemax(Nfile)
	character*3 pcu
      character*50 filename(jfile_num),user_gti_file

      character*80 object_name

      character*80 errmessage,comment
      logical casesan,gtinotfits
      integer itstart(500),itstop(500)
	integer itstartu(500),itstopu(500)

        integer status,unit,readwrite,blocksize
      logical anynull

      real*8 timem(NN)
      real enem(NN)
      integer lxpm(NN),ilaym(NN)

        casesan=.FALSE.
	

        call read_usergti(user_gti_file,tstartu,tstopu,jgtiu,gtinotfits)
     
 

         deltata = 10e-6
 

         write(*,*) "No. of energy bins", jfile_num

         

         do j=1,jfile_num
            nrows(j) = 0
         enddo



        status=0
      call ftgiou(unit,status)
      if (status .gt. 0)call printerror(status)
      readwrite=0
      call ftopen(unit,filename(1),readwrite,blocksize,status)
      if (status .gt. 0)then
      call printerror(status)
      write(*,*) 'event file not found'
      write(*,*) filename(1)
      stop
      endif
      

      call FTGKYD(unit,'TSTART',tstart(1),comment,status)
      call FTGKYD(unit,'TSTOP',tstop(1),comment,status)

      if(jgtiu .gt. 0)then
         if(tstartu(1) .gt. tstart(1))then
            do j=1,jgtiu
               tstartu(j) = tstartu(j)-tstart(1)
               tstopu(j) = tstopu(j)-tstart(1)
               
            enddo
         endif
      endif

!      write(*,*) tstart(1),tstop(1)
     

      ntable = 2
      call ftmahd(unit,ntable,hdutype,status)
      if (status .gt. 0)call printerror(status)

      call ftgnrw(unit,nrowsF,status)


      if(nrowsf .gt. NN-1)then
         write(*,*) "no of events too large: ",nrowf
         write(*,*) "taking only: ", NN-1, ' events'
         nrowsf=NN-1
      endif   
   

      irow=1
      ifelem=1
      call FTGCNO(unit,casesan,'Time',icol,status)
        call ftgcvd(unit,icol,irow,ifelem,nrowsf,nullj,timem,anynull
     1 ,status)

        if (status .gt. 0)call printerror(status)

        irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'Energy',icol,status)
        call ftgcve(unit,icol,irow,ifelem,nrowsf,nullj,enem,anynull
     1 ,status)

        irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'LAXPC_NO.',icol,status)
        call ftgcvj(unit,icol,irow,ifelem,nrowsf,nullj,lxpm,anynull
     1 ,status)

        irow=1
        ifelem=1
        call FTGCNO(unit,casesan,'layer',icol,status)
        call ftgcvj(unit,icol,irow,ifelem,nrowsf,nullj,ilaym,anynull
     1 ,status)
        
    

        if (status .gt. 0)call printerror(status)

       


        if (status .gt. 0)call printerror(status)
        

      

c$$$ 10    continue
c$$$       read(10,*,end=20) timea,ia,ia,Ene,lxp
       do i =1,nrowsf
          lxp = lxpm(i)
          ene=enem(i)
          timea=timem(i)
         
	if(pcu .ne. 'all')then
 
                    if(pcu .eq. '1  ')then
                if(lxp .ne. 1)cycle
             endif
             if(pcu .eq. '2  ')then
                if(lxp .ne. 2)cycle
             endif
             if(pcu .eq. '3  ')then
                if(lxp .ne. 3)cycle
             endif
             if(pcu .eq. '12 ')then
                if(lxp .eq. 3)cycle
             endif
             if(pcu .eq. '23 ')then
                if(lxp .eq. 1)cycle
             endif
             if(pcu .eq. '13 ')then
                if(lxp .eq. 2)cycle
             endif
               if(pcu .eq. '21 ')then
                if(lxp .eq. 3)cycle
             endif
             if(pcu .eq. '32 ')then
                if(lxp .eq. 1)cycle
             endif
             if(pcu .eq. '31 ')then
                if(lxp .eq. 2)cycle
             endif

       endif
       if(ilayer .gt. 0)then
          if(ilayer .ne. ilaym(i))cycle
       endif
       
       jfile=0
       jfiles=1
 11    continue
       
 
       if(Ene .ge. Enemin(jfiles) .and. Ene .le. Enemax(jfiles))then
       jfile=jfiles
       else
         
       jfiles=jfiles+1
       if(jfiles .le. jfile_num)goto 11
       endif
      
       if(jfile .ne. 0)then
          jshift = (jfile-1)*NNC+1
        time(jshift+nrows(jfile))=timea
        nrows(jfile)=nrows(jfile)+1
         if(nrows(jfile) .gt. NNC)then
         write(*,*) 'too many data points',nrows(jfile),NNC,jfile
         stop
        endif
       endif
      
       enddo
 
       
      

       do jfile=1,jfile_num

          


      write(*,*)"No.of events in the ",jfile," data set = ",nrows(jfile)
       
       
      

       if(jfile .eq. 1)then
          ibin=1
!      ibin = nint((1./(2.*freq_max))/deltata)
      if(ibin .eq. 0)ibin=1

      deltat=ibin*deltata

      
       jgti=1
       
     
     


          timemem=tstart(1)
          

          do j=1,jgti
           itstart(j) = int((tstart(j)-timemem)/deltat)+1 
           itstop(j) = int((tstop(j)-timemem)/deltat)+1 
           
          enddo 
	if(jgtiu .ne. 0)then
	 do j=1,jgtiu
           itstartu(j) = int((tstartu(j))/deltat)+1 
	
           itstopu(j) = int((tstopu(j))/deltat)+1 
           
          enddo 
	endif

          deltatb=deltata
          
          Tot_time = (tstop(jgti)-timemem)
          imax = Tot_time/deltat
!          timemem=time(1)
!          Tot_time = (time(nrows)-time(1))
c$$$           if(imax .gt. NN)then
c$$$         write(*,*) 'too many LC points',imax,NN
c$$$         imax=NN
c$$$          endif
          

     

      endif

      ave(jfile) = nrows(jfile)*deltat/Tot_time

!      write(*,*) nrows(jfile),jfile
!      write(*,*) ave(jfile),'average',Tot_time,timemem,tstop(jgti)

      
 

      
      enddo
  

      

      end

C *************************************************************************
      subroutine printerror(status)

C  This subroutine prints out the descriptive text corresponding to the
C  error status value and prints out the contents of the internal
C  error message stack generated by FITSIO whenever an error occurs.

      integer status
      character errtext*30,errmessage*80

C  Check if status is OK (no error); if so, simply return
      if (status .le. 0)return

C  The FTGERR subroutine returns a descriptive 30-character text string that
C  corresponds to the integer error status number.  A complete list of all
C  the error numbers can be found in the back of the FITSIO User's Guide.
      call ftgerr(status,errtext)
      print *,'FITSIO Error Status =',status,': ',errtext

C  FITSIO usually generates an internal stack of error messages whenever
C  an error occurs.  These messages provide much more information on the
C  cause of the problem than can be provided by the single integer error
C  status value.  The FTGMSG subroutine retrieves the oldest message from
C  the stack and shifts any remaining messages on the stack down one
C  position.  FTGMSG is called repeatedly until a blank message is
C  returned, which indicates that the stack is empty.  Each error message
C  may be up to 80 characters in length.  Another subroutine, called
C  FTCMSG, is available to simply clear the whole error message stack in
C  cases where one is not interested in the contents.
      call ftgmsg(errmessage)
      do while (errmessage .ne. ' ')
          print *,errmessage
          call ftgmsg(errmessage)
      end do
      end
C *************************************************************************
      subroutine deletefile(filename,status)

C  A simple little routine to delete a FITS file

      integer status,unit,blocksize
      character*(*) filename

C  Simply return if status is greater than zero
      if (status .gt. 0)return

C  Get an unused Logical Unit Number to use to open the FITS file
      call ftgiou(unit,status)

C  Try to open the file, to see if it exists
      call ftopen(unit,filename,1,blocksize,status)

      if (status .eq. 0)then
C         file was opened;  so now delete it 
          call ftdelt(unit,status)
      else if (status .eq. 103)then
C         file doesn't exist, so just reset status to zero and clear errors
          status=0
          call ftcmsg
      else
C         there was some other error opening the file; delete the file anyway
          status=0
          call ftcmsg
          call ftdelt(unit,status)
      end if

C  Free the unit number for later reuse
      call ftfiou(unit, status)
      end
